<?php
function Gradebook_Instructions()
{
  global $wpdb;
  global $current_user;
  get_currentuserinfo();
   
  if (is_user_logged_in())
  {  
	$User_rol = $wpdb->get_row($wpdb->prepare("SELECT User_login, User_role FROM gb_user_table WHERE User_login='".$current_user->user_login."'"));
	?><h1>Gradebook Instructions</h1>
	<?php if (($User_rol->User_role)=='Administrator')
			{
			?><div width=auto   style="background: #ededed; padding-left: 5px; border: 5px ridge #d3d1d1;"><br></br>	
	
	<h2>Administrator</h2>

          <img width="550" height="450" src="./wp-content/plugins/Community Gradebook/images/pic1.jpg" alt="Administrator Options Screen" /><br><br></br></br>

	<b>1. Add User/Role</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Administrators can add new Gradebook Administrator/Faculty's and TA's.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>User Id</u>:</b> Enter the user Id (the local user id of the person on the server)<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>User Role</u>:</b> Select the Users Role from the options (Administrator/Faculty/Teacher Assistant)<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Click Add.<br><br></br></br>

	<b>2. Delete User</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Administrators can delete other Gradebook users using this option.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>User Id</u>:</b> Select the user that needs deleted from the drop down list.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Click Delete.<br><br></br></br>

	<b>3. Edit General Information</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Administrators can set the current term as well as add new terms to the Term list.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Current Term</u>:</b> To update the current term, type down the current term here and click "update".<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><i>Format:("Term" "Year") e.g., Fall 2010</i></b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Term List</u>:</b> To add more terms to the term list, go to the end of the line and type down the term<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;to be added following a "/". <b><i>Format: (***/***/***/"Term" "Year") eg: Fall 2010</i></b><br></br><br></br>

	<b>4. Add Course</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Administrators can add a new course using this option.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Reference Number</u>:</b> Enter the reference number of the course (The reference number is a unique<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;number that most universities create to uniquely identify courses, it is called a "CRN" short for course<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;reference number at Temple University) <br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Course No</u>:</b> Enter the course number (e.g., MIS 2101).<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Course Title</u>:</b> Enter the title of the course.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Course Section</u>:</b>  Enter the section of the course. Eg: 001<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Instructor id</u>:</b> Select the user id of the instructor who is teaching this course.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;If does not exist add the instructor first.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Course Term</u></b>: Enter the term in which this course is being taught (e.g., Fall 2010).<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Click "Add Course".

    </div>
	   
	<?php }
	
	if ((($User_rol->User_role)=='Administrator') OR (($User_rol->User_role)=='Faculty') OR (($User_rol->User_role)=='Teacher Assistant'))
	{
	?><div width=auto   style="background: #ededed; padding-left: 5px; border: 5px ridge #d3d1d1;"><br></br>
	
	<h2>Faculty</h2>
	
	      <img width="550" height="450" src="./wp-content/plugins/Community Gradebook/images/pic2.jpg" alt="Administrator Options Screen" /><br><br></br></br>
		  
	<b>1. View Student Grades</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Select the desired course from the list of available courses.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Note: The course list is limited to the courses taught by the logged in faculty member.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;(based on their user id).<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Click "View Grades".<br></br><br></br>

	<b>2. Upload Grade</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Select Course</u>:</b> Select a course for which you would like to upload grades.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Note: You can only upload grades for courses being taught during the current semester.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;If you do not see your course, please contact the system administrator.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Upload File</u>:</b> Select the "CSV" file you would like to upload.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Note: Files have to be in "comma separated value (CSV)" format (also known as comma delimited);<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;each record in the CSV file has to be on a separate row (line). Microsoft Excel produces<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;CSV files that are compatible with this plug-in. Save and manage your grades in the Excel<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;native format. When you are ready to upload, click File, Save As, and then choose<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;"CSV (comma delimited)" for the "type."  A CSV file can be opened in any text editor and would appear as follows:<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Eg CSV file: <br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><i>Name,Email,Grade<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;John,John@example.com,A<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Tom,Tom@example.com,A<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Jack,Jack@example.com,A</i></b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Email Column Name</u>:</b> Name of the column that has the email addresses.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;In the above example "Email Column Name:" is "Email". This column is important<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;because the email address of the student is used to provide individual students access to their grades. <br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Checkbox for deleting previous grades</u>:</b> By default whenever a grade file is uploaded, if there exist<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;a student email, for the same course and section and term. Then the data is just updated. If you want to<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;enter a completely new grade file and delete existing data for this course, and then please check this box.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Using the above example, if we upload a grade file like this:<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;<b><i>Name,Email,Grade,Grade2<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;John,John@example.com,B,A</i></b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;If the <b>checkbox is not ticked</b>, only the record of the student with email address "john@example.com" will be<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;updated. The rest of the records will not be affected.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;If the <b>checkbox is ticked</b>, first, all the records for the particular course for that term will be deleted.<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;And only the above record will be added.<br><br></br></br>

	<b>3. Email</b><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;You can opt to send students an email notification about the availability of new grades.<br></br>
	
	&nbsp;&nbsp;&nbsp;&nbsp;<b><u>Note</u>:</b> : To customize the default message, please edit the subject and message. To personalize the<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;message, place the column name of the name field in your CSV file in the message body using [square brackets]. <br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;For example, to send a notification email with the following message body:<br></br><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Eg: (using the above CSV file), I you want to send out a notification email saying<br></br><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Dear John, ... <br></br><br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Add the following text to the message body (the example assumes that the <br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;column containing names in your CSV file is titled Name) :<br></br>
	&nbsp;&nbsp;&nbsp;&nbsp;Dear [Name], ...<br></br>

	
	</div><br></br>
	<?php }?>
	   <div width=auto   style="background: #ededed; padding-left: 5px; border: 5px ridge #d3d1d1;"><br></br>
	<b><i>Faculty/Staff please <u>log in</u> to see more specific instructions</i></b>
    </div><?php
  } 
  else
  {
     echo "You have to be logged in to view this page";
  }
}  
?>