<?php
//Community Gradebook Database Install/Uninstall Form
$ldap_dirname_basic = dirname(__FILE__);
require_once($ldap_dirname_basic."/functions.php");
require_once($ldap_dirname_basic."/ldap.php");

add_action('admin_menu', 'GB_Database_Menu');
function GB_Database_Menu() 
{ 
	global $wpdb;
	if (is_main_site())
	{	
			add_options_page('Gradebook Options', 'Gradebook Management',9,'GB_DB_Options','GB_Database_Options'); 
	}
}

function table_exists($table_name)
{
    $table = mysql_query("show tables like '" .
    $table_name . "'");

    if(mysql_fetch_row($table) === false)
	{
		return(false);
	}
	else
	{
		return(true);
	}
}

function GB_Database_Options()
{
	global $wpdb;
	global $current_user;
	get_currentuserinfo();
	echo '<div class="wrap"><form action="" method="post">';
	echo '<h1> <center>Gradebook Database Management</center></h1>';
	echo '<br><br><h2>Note</h2>';
	echo '<ul><li><b>Only the main administrators of the site will be able to view this page.</b></li>';
	echo '<li><b>These options are visible only on the dashboard of the main site.</b></li>';
	echo '<li><b>This plugin is compatible with wordpress multi-site as well as regular site.</b></li>';
	echo '<li><b>The gradebook plugin database has to be installed only once whether multi-site or regular, but it needs to installed before the first use.</b></li>';
	echo '<li><b>See below for instructions on how to install the database.</b></li>';
	echo '</ul>';
	echo '<br><br><h2>Instructions</h2>';
	echo '<ul><li><b>Installation is pretty simple, just hit the install button on this screen and it will be installed (needs to be done only once whether multi-site or not).</b></li>';
	echo '<li><b>When uninstalling this plugin, before you deactivate make sure to uninstall the database by clicking the uninstall button on this screen (this action is not reversible and you will lose all the gradebook data so make sure you want uninstall and make a backup of the database as well).</b></li>';
	echo '</ul>';
	echo '<br><br></br></br>';
	echo '<br><br><h3>Install</h3>';
	echo '<input type="submit" name="Install" id="Install" value="Install" tabindex="32"  />';
	echo ' Click Here to install the Database';
	echo '<br><br></br>';
	echo '<br><br><h3>Uninstall</h3>';
	echo '<input type="submit" name="Uninstall" id="Uninstall" value="Uninstall" tabindex="32"  />';
	echo ' Click Here to Uninstall the Database<br></br>';
	echo '<input type="submit" name="Uninstall_with_backup" id="Uninstall_with_backup" value="Backup and Uninstall" tabindex="32"  />';
	echo ' Click Here to Backup the Gradebook Database and then Uninstall <b>(Recommended)</b>';
	echo '</form></div>';  
	
	
	//Insert User Code
	echo "<br></br><b>Add User/Role</b><br></br>";
	echo '<form action="" method="post" name="user_table" enctype="multipart/form-data"><table>
			<tr><td>User ID:</td>
				<td><input type="text" name="login"></td></tr>
			<tr><td>User Role</td>
				<td> <SELECT name="role" style="width:220px"><OPTION>Select</OPTION>
				     <OPTION>Administrator</OPTION>
					 <OPTION>Faculty</OPTION>
					 <OPTION>Teacher Assistant</OPTION></SELECT></td></tr>
			<tr><td></td>
				<td><input type="submit" name="submit" value="Add"></td></tr>
		</table></form>'; 
	$post_submit = esc_html($_POST['submit']);
	$post_login = esc_html($_POST['login']);
	$post_role = esc_html($_POST['role']);
	if($post_submit)
    {
		if((($post_login)=="") OR (($post_role)=="Select"))
		{
		  echo "AccessNet ID field cannot be blank and User Role cannot be Select";
		}
		else
		{
		  $ch_user = $wpdb->get_var($wpdb->prepare("SELECT COUNT(*) FROM gb_user_table WHERE = user_login'".$post_login."'"));
		  if($ch_user==0)
		  {
			check_user(($post_login), $data);
			if(($data[0][mail][0])=="")
			{
				if(username_exists($post_login))
				{
					$results = $wpdb->query($wpdb->prepare("INSERT INTO gb_user_table (User_login, User_email, User_role, User_name) VALUES ('".$post_login."', '".$data[0][mail][0]."', '".$post_role."', '".$data[0][cn][0]."')"));
				}
				else
				{
					echo "Invalid User ID";
				}
			}
			else
			{
				$results = $wpdb->query($wpdb->prepare("INSERT INTO gb_user_table (User_login, User_email, User_role, User_name) VALUES ('".$post_login."', '".$data[0][mail][0]."', '".$post_role."', '".$data[0][cn][0]."')"));
			}
		  }
		  else
		  {
			echo "User has been already added";
		  }
		}
	} 	 
	$post_uninstall = esc_html($_POST['Uninstall']);
	$post_uninstall_w_bk = esc_html($_POST['Uninstall_with_backup']);
	$post_install = esc_html($_POST['Install']);
	
	if($post_uninstall)
	{
		drop_tables();		
	}
	if($post_uninstall_w_bk)
	{
		Backup_Data();		
	}
	if($post_install)
	{
		install();
	}	
}

function Backup_Data()
{
	global $wpdb;
	$filename = 'gb_backup.sql';

	$bk_out.="\n\n\n#Backup of the Wordpress Database begins here\n#****************************************************************************************\n\n";
	$result = mysql_query("SHOW TABLES;");
	
	$tables = array('gradebook','gb_user_table','general_info','course_table');
	foreach ($tables as $table ) {
	// dump data
	$bk_out.=datadump($table, true, true);
	}		    
	
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Content-Type: text/plain");
    header("Content-Disposition: attachment; filename=$filename");
    echo $bk_out;
	drop_tables();
	exit; 
	
}


function drop_tables()
{  
    global $wpdb;
	$table[1] = "gb_user_table";  
	$table[2] = "general_info"; 
	$table[3] = "gradebook";
	$table[4] = "course_table";
	
	for($i=1; $i<5; $i++)
	{
		if (table_exists($table[$i]))
		{
			$wpdb->query($wpdb->prepare("DROP TABLE IF EXISTS $table[$i]"));  
			if (table_exists($table[$i]))
			{
				echo "<br></br>Error dropping <b>$table[$i]</b>";
			}
			else
			{
			    echo "<br></br><b>$table[$i]</b> has been dropped";				
			}
		}
		else
		{
			echo "<br></br><b>$table[$i]</b> does not exist in the Database";
		}
	}		
}

function install () 
{
	global $wpdb;
	$table[1] = "gb_user_table";  
	$table[2] = "general_info"; 
	$table[3] = "gradebook";
	$table[4] = "course_table";
	
	$sql[1] = "CREATE TABLE IF NOT EXISTS gb_user_table (User_login varchar(45) NOT NULL, User_email varchar(100) NOT NULL, User_role varchar(45) NOT NULL, Timestamp timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP, User_name varchar(45) NOT NULL, PRIMARY KEY (User_login));";
	$sql[2] = "CREATE TABLE IF NOT EXISTS general_info (id int(10) unsigned NOT NULL AUTO_INCREMENT, Title varchar(45) NOT NULL, Value varchar(250) DEFAULT NULL, Value_Name varchar(45) NOT NULL, PRIMARY KEY (id));";	           
	$sql[3] = "CREATE TABLE IF NOT EXISTS gradebook (GB_ID int(10) unsigned NOT NULL AUTO_INCREMENT, Course_No varchar(20) NOT NULL, Email varchar(100) NOT NULL, Data_Title varchar(1000) NOT NULL, Data_Value varchar(1000) NOT NULL, Term varchar(45) NOT NULL, TimeStamp timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP, Section varchar(45) NOT NULL, PRIMARY KEY (GB_ID));";
	$sql[4] = "CREATE TABLE IF NOT EXISTS course_table (Course_No varchar(20) NOT NULL, Course_Title varchar(50) NOT NULL, Section varchar(10) NOT NULL, CRN varchar(15) NOT NULL, Instructor_login varchar(45) NOT NULL, Term varchar(45) NOT NULL, Timestamp timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP, PRIMARY KEY (CRN));";
	$insert_sql[2] = "INSERT INTO general_info (id,Title,Value,Value_Name) VALUES (1,'Current Term','Fall 2010','Cur_Term_Val'), (2,'Term List','Select/Fall 2010/Spring 2010/Fall 2011/Spring 2011/Fall 2012/Spring 2012','Term_List_Val');";

	for($i=1; $i<5; $i++)
	{
		if (table_exists($table[$i]))
		{
			echo "<br></br><b>$table[$i] </b>already exists in the Database";
		}
		else
		{			
			$wpdb->query($wpdb->prepare($sql[$i]));
			if (table_exists($table[$i]))
			{
				echo "<br></br><b>$table[$i] </b>has been Successfully created";								
			}
			else
			{
			    echo "<br></br>Error creating <b>$table[$i]</b>";
			}
		}
	}
	if (table_exists($table[2]))
		{
			$wpdb->query($wpdb->prepare($insert_sql[2]));
		}
		
}

function datadump($table, $drop = true, $stripapos = true)
{
	  $result     = "# Dump of $table \n";
	  $result    .= "# Dump DATE : " . date("d-M-Y") ."\n\n";
	  if ( $drop ) {
	    if ( $stripapos ) {
	      $result    .= "DROP TABLE IF EXISTS $table;\n";
	      // dump create table
	      $createTableQuery = mysql_query("SHOW CREATE TABLE ".$table.";");
	      $createTable      = mysql_fetch_row($createTableQuery);
	      $result          .= str_replace('`', '', $createTable[1]).";\n\n\n\n"; 
	    } else {
	      $result    .= "DROP TABLE IF EXISTS `$table`;\n";
	      // dump create table
	      $createTableQuery = mysql_query("SHOW CREATE TABLE ".$table.";");
	      $createTable      = mysql_fetch_row($createTableQuery);
	      $result          .= $createTable[1].";\n\n\n\n";   
	    }
	  } else {
	    $result    .= "TRUNCATE TABLE $table;\n";
	  }
	   
	  $query      = mysql_query("SELECT * FROM $table");
	  $num_fields = @mysql_num_fields($query);
	  $numrow     = mysql_num_rows($query);
	  
	  $columnsRes = mysql_query("SHOW COLUMNS FROM $table;");
	  $columns = array();
	  
	  while ( $row = mysql_fetch_assoc($columnsRes) ) {
	    $columns[$row['Field']] = $row;
	  }
	  
	  while ( $row = mysql_fetch_assoc($query) ) {
	    $result .= "INSERT INTO ".$table." VALUES(";
	  
	    $fields = array();
	  
	    foreach ( $row as $field => $data ) {
	      if ( strpos(strtolower($columns[$field]['Type']), 'int') !== false
	        || strpos(strtolower($columns[$field]['Type']), 'float') !== false
	        || strpos(strtolower($columns[$field]['Type']), 'tinyint') !== false ) {
	        if ( strlen($data) > 0 ) {
	          $fields[] = $data;
	        } else {
	          if ( strtolower($columns[$field]['Null']) == 'no' ) {
	            $fields[] = 0;
	          } else {
	            $fields[] = "NULL";
	          }       
	        }
	      } elseif ( strpos(strtolower($columns[$field]['Type']), 'datetime') !== false ) {
	        if ( strlen($data) > 0 ) {      
	          $fields[] = "\"".$data."\"" ;
	        } else {
	          if ( strtolower($columns[$field]['Null']) == 'no' ) {
	            $fields[] = '""';
	          } else {
	            $fields[] = "NULL";
	          }
	        }
	      } elseif ( strpos(strtolower($columns[$field]['Type']), 'time') !== false ) {
	        if ( strlen($data) > 0 ) {
	          $fields[] = "\"".$data."\"" ;
	        } else {
	          if ( strtolower($columns[$field]['Null']) == 'no' ) {
	            $fields[] = '""';
	          } else {
	            $fields[] = "NULL";
	          }
	        }       
	      } elseif ( strpos(strtolower($columns[$field]['Type']), 'varchar') !== false
	       || strpos(strtolower($columns[$field]['Type']), 'text') !== false
	       || strpos(strtolower($columns[$field]['Type']), 'longtext') !== false
	       || strpos(strtolower($columns[$field]['Type']), 'mediumtext') !== false ) {
	        $data = addslashes($data);
	        $data = trim(ereg_replace("\n", "\\n", $data));
	        if ( strlen($data) > 0 ) {
	          $fields[] = "\"".$data."\"" ;
	        } else {
	          if ( strtolower($columns[$field]['Null']) == 'no' ) {
	            $fields[] = '""';
	          } else {
	            $fields[] = "NULL";
	          }
	        }       
	      } else {
	        // $columns[$field]['Type'] will contain the datatype
	        if ( strlen($data) > 0 ) {
	          $fields[] = "\"".$data."\"" ;
	        } else {
	          if ( strtolower($columns[$field]['Null']) == 'no' ) {
	            $fields[] = '""';
	          } else {
	            $fields[] = "NULL";
	          }
	        }       
	      }
	    }
	    $result .= implode(',', $fields);
	    $result .= ");\n";
	  }
  return $result . "\n\n\n";
}
?>